void main()
{
register int i;
register char cr, dr;
static char *piapa, *piapb, *piapc, *piactl, *uartdr, *uartcr;

   piapa = 0x5001;	/* subtract 4000 for DS offset */
   piapb = 0x5003;
   piapc = 0x5005;
   piactl = 0x5007;   
   uartdr = 0x4000;	/* UART data register */
   uartcr = 0x4002;	/* UART control register */

   *piactl = 128;	/* all PIA ports as outputs */

   *uartcr = 0x0;	
   *uartcr = 0x0;	/* assume worst case UART powerup; reset */
   *uartcr = 0x0;
   *uartcr = 0x40;

   *uartcr = 0xCD;	/* 2 stop bits, parity disabled, 8 bits long, /16  */
   *uartcr = 0x36;	/* enable Rx, DTR low, reset error, RTS low        */
   
   while (1)
     {
     cr = *uartcr;		/* UART status read */
     *piapa = (char) cr;	/* output status to PIA */

     if ((cr&2)>>1)		/* if full, read UART */
        {
        dr = *uartdr;
        *piapa = (char) dr;
	}
     }
}
